Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_interface.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_interface.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_interface.F90	(revision 4853)
@@ -68,10 +68,16 @@
 
     ! Load the look-up tables from files in the specified directory
-    if (config%i_gas_model == IGasModelMonochromatic) then
+    if (config%i_gas_model_sw == IGasModelMonochromatic) then
       call setup_gas_optics_mono(config, trim(config%directory_name))
-    else if (config%i_gas_model == IGasModelIFSRRTMG) then
-      call setup_gas_optics_rrtmg(config, trim(config%directory_name))
-    else if (config%i_gas_model == IGasModelECCKD) then
-      call setup_gas_optics_ecckd(config)
+    else
+      ! Note that we can run RRTMG and ECCKD for different parts of
+      ! the spectrum: the setup routines only configure the relevant
+      ! part.
+      if (config%i_gas_model_sw == IGasModelIFSRRTMG .or. config%i_gas_model_lw == IGasModelIFSRRTMG) then
+        call setup_gas_optics_rrtmg(config, trim(config%directory_name))
+      end if
+      if (config%i_gas_model_sw == IGasModelECCKD .or. config%i_gas_model_lw == IGasModelECCKD) then
+        call setup_gas_optics_ecckd(config)
+      end if
     end if
 
@@ -122,5 +128,5 @@
 
     if (config%do_clouds) then
-      if (config%i_gas_model == IGasModelMonochromatic) then
+      if (config%i_gas_model_sw == IGasModelMonochromatic) then
         !      call setup_cloud_optics_mono(config)
       elseif (config%use_general_cloud_optics) then
@@ -132,5 +138,5 @@
 
     if (config%use_aerosols) then
-      if (config%i_gas_model == IGasModelMonochromatic) then
+      if (config%i_gas_model_sw == IGasModelMonochromatic) then
 !        call setup_aerosol_optics_mono(config)
       else 
@@ -167,10 +173,14 @@
     type(gas_type),    intent(inout) :: gas
 
-    if (config%i_gas_model == IGasModelMonochromatic) then
+    if (config%i_gas_model_sw == IGasModelMonochromatic) then
       call set_gas_units_mono(gas)
-    elseif (config%i_gas_model == IGasModelECCKD) then
+    elseif (config%i_gas_model_sw == IGasModelIFSRRTMG &
+         &  .or. config%i_gas_model_lw == IGasModelIFSRRTMG) then
+      ! Convert to mass-mixing ratio for RRTMG; note that ecCKD can
+      ! work with this but performs an internal scaling
+      call set_gas_units_ifs(gas)
+    else
+      ! Use volume mixing ratio preferred by ecCKD
       call set_gas_units_ecckd(gas)
-    else
-      call set_gas_units_ifs(gas)
     end if
 
@@ -196,5 +206,5 @@
     use radiation_io,             only : nulout
     use radiation_config,         only : config_type, &
-         &   IGasModelMonochromatic, IGasModelIFSRRTMG, &
+         &   IGasModelMonochromatic, IGasModelIFSRRTMG, IGasModelECCKD, &
          &   ISolverMcICA, ISolverSpartacus, ISolverHomogeneous, &
          &   ISolverTripleclouds
@@ -227,6 +237,4 @@
     use radiation_general_cloud_optics, only : general_cloud_optics
     use radiation_aerosol_optics, only : add_aerosol_optics
-    USE mod_phys_lmdz_para
-
 
     ! Inputs
@@ -238,5 +246,5 @@
     type(thermodynamics_type),intent(in)   :: thermodynamics
     type(gas_type),           intent(in)   :: gas
-    type(cloud_type),        intent(inout):: cloud
+    type(cloud_type),         intent(inout):: cloud
     type(aerosol_type),       intent(in)   :: aerosol
     ! Output
@@ -297,22 +305,6 @@
 
     real(jphook) :: hook_handle
-    integer :: jcol, jlev
 
     if (lhook) call dr_hook('radiation_interface:radiation',0,hook_handle)
-
-    if (config%i_solver_sw == ISolverSPARTACUS) then
-         print*,'Dans radiation, mpi_rank, omp_rank, size, chape inv_cloud = ',&
-              mpi_rank, omp_rank, &
-              shape(cloud%inv_cloud_effective_size), &
-              size(cloud%inv_cloud_effective_size)   
-!         do jcol=istartcol, iendcol
-!              do jlev=1,nlev
-!              print*,'Entree radiation_interf, mpi_rank, omp_rank, jcol, jlev &
-!           &  cloud%inv_cloud_effective_size =',mpi_rank, omp_rank, jcol, jlev, &
-!           &  cloud%inv_cloud_effective_size(jcol,jlev)
-!              enddo
-!          enddo
-    endif
-!    cloud%inv_cloud_effective_size=0.05_jprb
 
     if (thermodynamics%pressure_hl(istartcol,2) &
@@ -339,21 +331,26 @@
       ! incoming shortwave flux at each g-point, for the specified
       ! range of atmospheric columns
-      if (config%i_gas_model == IGasModelMonochromatic) then
+      if (config%i_gas_model_sw == IGasModelMonochromatic) then
         call gas_optics_mono(ncol,nlev,istartcol,iendcol, config, &
              &  single_level, thermodynamics, gas, lw_albedo, &
              &  od_lw, od_sw, ssa_sw, &
              &  planck_hl, lw_emission, incoming_sw)
-      else if (config%i_gas_model == IGasModelIFSRRTMG) then
-        call gas_optics_rrtmg(ncol,nlev,istartcol,iendcol, config, &
-             &  single_level, thermodynamics, gas, &
-             &  od_lw, od_sw, ssa_sw, lw_albedo=lw_albedo, &
-             &  planck_hl=planck_hl, lw_emission=lw_emission, &
-             &  incoming_sw=incoming_sw)
       else
-        call gas_optics_ecckd(ncol,nlev,istartcol,iendcol, config, &
-             &  single_level, thermodynamics, gas, &
-             &  od_lw, od_sw, ssa_sw, lw_albedo=lw_albedo, &
-             &  planck_hl=planck_hl, lw_emission=lw_emission, &
-             &  incoming_sw=incoming_sw)
+        if (config%i_gas_model_sw == IGasModelIFSRRTMG &
+             &   .or. config%i_gas_model_lw == IGasModelIFSRRTMG) then
+          call gas_optics_rrtmg(ncol,nlev,istartcol,iendcol, config, &
+               &  single_level, thermodynamics, gas, &
+               &  od_lw, od_sw, ssa_sw, lw_albedo=lw_albedo, &
+               &  planck_hl=planck_hl, lw_emission=lw_emission, &
+               &  incoming_sw=incoming_sw)
+        end if
+        if (config%i_gas_model_sw == IGasModelECCKD &
+             &   .or. config%i_gas_model_lw == IGasModelECCKD) then
+          call gas_optics_ecckd(ncol,nlev,istartcol,iendcol, config, &
+               &  single_level, thermodynamics, gas, &
+               &  od_lw, od_sw, ssa_sw, lw_albedo=lw_albedo, &
+               &  planck_hl=planck_hl, lw_emission=lw_emission, &
+               &  incoming_sw=incoming_sw)
+        end if
       end if
 
@@ -368,5 +365,5 @@
         ! Compute hydrometeor absorption/scattering properties in each
         ! shortwave and longwave band
-        if (config%i_gas_model == IGasModelMonochromatic) then
+        if (config%i_gas_model_sw == IGasModelMonochromatic) then
           call cloud_optics_mono(nlev, istartcol, iendcol, &
                &  config, thermodynamics, cloud, &
@@ -387,5 +384,5 @@
 
       if (config%use_aerosols) then
-        if (config%i_gas_model == IGasModelMonochromatic) then
+        if (config%i_gas_model_sw == IGasModelMonochromatic) then
 !          call add_aerosol_optics_mono(nlev,istartcol,iendcol, &
 !               &  config, thermodynamics, gas, aerosol, & 
@@ -474,12 +471,4 @@
         else if (config%i_solver_sw == ISolverSPARTACUS) then
           ! Compute fluxes using the SPARTACUS shortwave solver
-!             cloud%inv_cloud_effective_size=0.05_jprb
-!             do jcol=istartcol, iendcol
-!              do jlev=1,nlev
-!              print*,'jcol, jlev, dans radiation_interf i &
-!               &       cloud%inv_cloud_effective_size =',jcol, jlev, &
-!               cloud%inv_cloud_effective_size(jcol,jlev)
-!              enddo
-!             enddo
           call solver_spartacus_sw(nlev,istartcol,iendcol, &
                &  config, single_level, thermodynamics, cloud, & 
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_mcica_lw.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_mcica_lw.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_mcica_lw.F90	(revision 4853)
@@ -19,4 +19,6 @@
 !   2017-10-23  R. Hogan  Renamed single-character variables
 
+#include "ecrad_config.h"
+
 module radiation_mcica_lw
 
@@ -124,4 +126,11 @@
     ! Identify clear-sky layers
     logical :: is_clear_sky_layer(nlev)
+
+    ! Temporary storage for more efficient summation
+#ifdef DWD_REDUCTION_OPTIMIZATIONS
+    real(jprb), dimension(nlev+1,2) :: sum_aux
+#else
+    real(jprb) :: sum_up, sum_dn
+#endif
 
     ! Index of the highest cloudy layer
@@ -179,6 +188,28 @@
 
       ! Sum over g-points to compute broadband fluxes
-      flux%lw_up_clear(jcol,:) = sum(flux_up_clear,1)
-      flux%lw_dn_clear(jcol,:) = sum(flux_dn_clear,1)
+#ifdef DWD_REDUCTION_OPTIMIZATIONS
+      sum_aux(:,:) = 0.0_jprb
+      do jg = 1,ng
+        do jlev = 1,nlev+1
+          sum_aux(jlev,1) = sum_aux(jlev,1) + flux_up_clear(jg,jlev)
+          sum_aux(jlev,2) = sum_aux(jlev,2) + flux_dn_clear(jg,jlev)
+        end do
+      end do
+      flux%lw_up_clear(jcol,:) = sum_aux(:,1)
+      flux%lw_dn_clear(jcol,:) = sum_aux(:,2)
+#else
+      do jlev = 1,nlev+1
+        sum_up = 0.0_jprb
+        sum_dn = 0.0_jprb
+        !$omp simd reduction(+:sum_up, sum_dn)
+        do jg = 1,ng
+          sum_up = sum_up + flux_up_clear(jg,jlev)
+          sum_dn = sum_dn + flux_dn_clear(jg,jlev)
+        end do
+        flux%lw_up_clear(jcol,jlev) = sum_up
+        flux%lw_dn_clear(jcol,jlev) = sum_dn
+      end do
+#endif
+
       ! Store surface spectral downwelling fluxes
       flux%lw_dn_surf_clear_g(:,jcol) = flux_dn_clear(:,nlev+1)
@@ -279,8 +310,10 @@
           else
             ! Clear-sky layer: copy over clear-sky values
-            reflectance(:,jlev) = ref_clear(:,jlev)
-            transmittance(:,jlev) = trans_clear(:,jlev)
-            source_up(:,jlev) = source_up_clear(:,jlev)
-            source_dn(:,jlev) = source_dn_clear(:,jlev)
+            do jg = 1,ng
+              reflectance(jg,jlev) = ref_clear(jg,jlev)
+              transmittance(jg,jlev) = trans_clear(jg,jlev)
+              source_up(jg,jlev) = source_up_clear(jg,jlev)
+              source_dn(jg,jlev) = source_dn_clear(jg,jlev)
+            end do
           end if
         end do
@@ -307,13 +340,36 @@
         
         ! Store overcast broadband fluxes
-        flux%lw_up(jcol,:) = sum(flux_up,1)
-        flux%lw_dn(jcol,:) = sum(flux_dn,1)
+#ifdef DWD_REDUCTION_OPTIMIZATIONS
+        sum_aux(:,:) = 0._jprb
+        do jg = 1, ng
+          do jlev = 1, nlev+1
+            sum_aux(jlev,1) = sum_aux(jlev,1) + flux_up(jg,jlev)
+            sum_aux(jlev,2) = sum_aux(jlev,2) + flux_dn(jg,jlev)
+          end do
+        end do
+        flux%lw_up(jcol,:) = sum_aux(:,1)
+        flux%lw_dn(jcol,:) = sum_aux(:,2)
+#else
+        do jlev = 1,nlev+1
+          sum_up = 0.0_jprb
+          sum_dn = 0.0_jprb
+          !$omp simd reduction(+:sum_up, sum_dn)
+          do jg = 1,ng
+            sum_up = sum_up + flux_up(jg,jlev)
+            sum_dn = sum_dn + flux_dn(jg,jlev)
+          end do
+          flux%lw_up(jcol,jlev) = sum_up
+          flux%lw_dn(jcol,jlev) = sum_dn
+        end do
+#endif
 
         ! Cloudy flux profiles currently assume completely overcast
         ! skies; perform weighted average with clear-sky profile
-        flux%lw_up(jcol,:) =  total_cloud_cover *flux%lw_up(jcol,:) &
-             &  + (1.0_jprb - total_cloud_cover)*flux%lw_up_clear(jcol,:)
-        flux%lw_dn(jcol,:) =  total_cloud_cover *flux%lw_dn(jcol,:) &
-             &  + (1.0_jprb - total_cloud_cover)*flux%lw_dn_clear(jcol,:)
+        do jlev = 1,nlev+1
+          flux%lw_up(jcol,jlev) =  total_cloud_cover *flux%lw_up(jcol,jlev) &
+             &       + (1.0_jprb - total_cloud_cover)*flux%lw_up_clear(jcol,jlev)
+          flux%lw_dn(jcol,jlev) =  total_cloud_cover *flux%lw_dn(jcol,jlev) &
+             &       + (1.0_jprb - total_cloud_cover)*flux%lw_dn_clear(jcol,jlev)
+        end do
         ! Store surface spectral downwelling fluxes
         flux%lw_dn_surf_g(:,jcol) = total_cloud_cover*flux_dn(:,nlev+1) &
@@ -335,6 +391,8 @@
         ! No cloud in profile and clear-sky fluxes already
         ! calculated: copy them over
-        flux%lw_up(jcol,:) = flux%lw_up_clear(jcol,:)
-        flux%lw_dn(jcol,:) = flux%lw_dn_clear(jcol,:)
+        do jlev = 1,nlev+1
+          flux%lw_up(jcol,jlev) = flux%lw_up_clear(jcol,jlev)
+          flux%lw_dn(jcol,jlev) = flux%lw_dn_clear(jcol,jlev)
+        end do
         flux%lw_dn_surf_g(:,jcol) = flux%lw_dn_surf_clear_g(:,jcol)
         if (config%do_lw_derivatives) then
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_mcica_sw.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_mcica_sw.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_mcica_sw.F90	(revision 4853)
@@ -18,4 +18,6 @@
 !   2017-10-23  R. Hogan  Renamed single-character variables
 
+#include "ecrad_config.h"
+
 module radiation_mcica_sw
 
@@ -119,4 +121,11 @@
     ! Total cloud cover output from the cloud generator
     real(jprb) :: total_cloud_cover
+
+    ! Temporary storage for more efficient summation
+#ifdef DWD_REDUCTION_OPTIMIZATIONS
+    real(jprb), dimension(nlev+1,3) :: sum_aux
+#else
+    real(jprb) :: sum_up, sum_dn_diff, sum_dn_dir
+#endif
 
     ! Number of g points
@@ -175,18 +184,47 @@
         
         ! Sum over g-points to compute and save clear-sky broadband
-        ! fluxes
-        flux%sw_up_clear(jcol,:) = sum(flux_up,1)
+        ! fluxes. Note that the built-in "sum" function is very slow,
+        ! and before being replaced by the alternatives below
+        ! accounted for around 40% of the total cost of this routine.
+#ifdef DWD_REDUCTION_OPTIMIZATIONS
+        ! Optimized summation for the NEC architecture
+        sum_aux(:,:) = 0.0_jprb
+        do jg = 1,ng
+          do jlev = 1,nlev+1
+            sum_aux(jlev,1) = sum_aux(jlev,1) + flux_up(jg,jlev)
+            sum_aux(jlev,2) = sum_aux(jlev,2) + flux_dn_direct(jg,jlev)
+            sum_aux(jlev,3) = sum_aux(jlev,3) + flux_dn_diffuse(jg,jlev)
+          end do
+        end do
+        flux%sw_up_clear(jcol,:) = sum_aux(:,1)
+        flux%sw_dn_clear(jcol,:) = sum_aux(:,2) + sum_aux(:,3)
         if (allocated(flux%sw_dn_direct_clear)) then
-          flux%sw_dn_direct_clear(jcol,:) &
-               &  = sum(flux_dn_direct,1)
-          flux%sw_dn_clear(jcol,:) = sum(flux_dn_diffuse,1) &
-               &  + flux%sw_dn_direct_clear(jcol,:)
-        else
-          flux%sw_dn_clear(jcol,:) = sum(flux_dn_diffuse,1) &
-               &  + sum(flux_dn_direct,1)
+          flux%sw_dn_direct_clear(jcol,:) = sum_aux(:,2)
         end if
+#else
+        ! Optimized summation for the x86-64 architecture
+        do jlev = 1,nlev+1
+          sum_up      = 0.0_jprb
+          sum_dn_diff = 0.0_jprb
+          sum_dn_dir  = 0.0_jprb
+          !$omp simd reduction(+:sum_up, sum_dn_diff, sum_dn_dir)
+          do jg = 1,ng
+            sum_up      = sum_up      + flux_up(jg,jlev)
+            sum_dn_diff = sum_dn_diff + flux_dn_diffuse(jg,jlev)
+            sum_dn_dir  = sum_dn_dir  + flux_dn_direct(jg,jlev)
+          end do
+          flux%sw_up_clear(jcol,jlev) = sum_up
+          flux%sw_dn_clear(jcol,jlev) = sum_dn_diff + sum_dn_dir
+          if (allocated(flux%sw_dn_direct_clear)) then
+            flux%sw_dn_direct_clear(jcol,jlev) = sum_dn_dir
+          end if
+        end do
+#endif
+        
         ! Store spectral downwelling fluxes at surface
-        flux%sw_dn_diffuse_surf_clear_g(:,jcol) = flux_dn_diffuse(:,nlev+1)
-        flux%sw_dn_direct_surf_clear_g(:,jcol)  = flux_dn_direct(:,nlev+1)
+        do jg = 1,ng
+          flux%sw_dn_diffuse_surf_clear_g(jg,jcol) = flux_dn_diffuse(jg,nlev+1)
+          flux%sw_dn_direct_surf_clear_g(jg,jcol)  = flux_dn_direct(jg,nlev+1)
+        end do
 
         ! Do cloudy-sky calculation
@@ -249,9 +287,11 @@
             else
               ! Clear-sky layer: copy over clear-sky values
-              reflectance(:,jlev) = ref_clear(:,jlev)
-              transmittance(:,jlev) = trans_clear(:,jlev)
-              ref_dir(:,jlev) = ref_dir_clear(:,jlev)
-              trans_dir_diff(:,jlev) = trans_dir_diff_clear(:,jlev)
-              trans_dir_dir(:,jlev) = trans_dir_dir_clear(:,jlev)
+              do jg = 1,ng
+                reflectance(jg,jlev) = ref_clear(jg,jlev)
+                transmittance(jg,jlev) = trans_clear(jg,jlev)
+                ref_dir(jg,jlev) = ref_dir_clear(jg,jlev)
+                trans_dir_diff(jg,jlev) = trans_dir_diff_clear(jg,jlev)
+                trans_dir_dir(jg,jlev) = trans_dir_dir_clear(jg,jlev)
+              end do
             end if
           end do
@@ -264,42 +304,73 @@
           
           ! Store overcast broadband fluxes
-          flux%sw_up(jcol,:) = sum(flux_up,1)
+#ifdef DWD_REDUCTION_OPTIMIZATIONS
+          sum_aux(:,:) = 0.0_jprb
+          do jg = 1,ng
+            do jlev = 1,nlev+1
+              sum_aux(jlev,1) = sum_aux(jlev,1) + flux_up(jg,jlev)
+              sum_aux(jlev,2) = sum_aux(jlev,2) + flux_dn_direct(jg,jlev)
+              sum_aux(jlev,3) = sum_aux(jlev,3) + flux_dn_diffuse(jg,jlev)
+            end do
+          end do
+          flux%sw_up(jcol,:) = sum_aux(:,1)
+          flux%sw_dn(jcol,:) = sum_aux(:,2) + sum_aux(:,3)
           if (allocated(flux%sw_dn_direct)) then
-            flux%sw_dn_direct(jcol,:) = sum(flux_dn_direct,1)
-            flux%sw_dn(jcol,:) = sum(flux_dn_diffuse,1) &
-                 &  + flux%sw_dn_direct(jcol,:)
-          else
-            flux%sw_dn(jcol,:) = sum(flux_dn_diffuse,1) &
-                 &  + sum(flux_dn_direct,1)
+            flux%sw_dn_direct(jcol,:) = sum_aux(:,2)
           end if
-
+#else
+          do jlev = 1,nlev+1
+            sum_up      = 0.0_jprb
+            sum_dn_diff = 0.0_jprb
+            sum_dn_dir  = 0.0_jprb
+            !$omp simd reduction(+:sum_up, sum_dn_diff, sum_dn_dir)
+            do jg = 1,ng
+              sum_up      = sum_up      + flux_up(jg,jlev)
+              sum_dn_diff = sum_dn_diff + flux_dn_diffuse(jg,jlev)
+              sum_dn_dir  = sum_dn_dir  + flux_dn_direct(jg,jlev)
+            end do
+            flux%sw_up(jcol,jlev) = sum_up
+            flux%sw_dn(jcol,jlev) = sum_dn_diff + sum_dn_dir
+            if (allocated(flux%sw_dn_direct)) then
+              flux%sw_dn_direct(jcol,jlev) = sum_dn_dir
+            end if
+          end do
+#endif
+          
           ! Cloudy flux profiles currently assume completely overcast
           ! skies; perform weighted average with clear-sky profile
-          flux%sw_up(jcol,:) =  total_cloud_cover *flux%sw_up(jcol,:) &
-               &  + (1.0_jprb - total_cloud_cover)*flux%sw_up_clear(jcol,:)
-          flux%sw_dn(jcol,:) =  total_cloud_cover *flux%sw_dn(jcol,:) &
-               &  + (1.0_jprb - total_cloud_cover)*flux%sw_dn_clear(jcol,:)
-          if (allocated(flux%sw_dn_direct)) then
-            flux%sw_dn_direct(jcol,:) = total_cloud_cover *flux%sw_dn_direct(jcol,:) &
-                 &  + (1.0_jprb - total_cloud_cover)*flux%sw_dn_direct_clear(jcol,:)
-          end if
+          do jlev = 1, nlev+1
+            flux%sw_up(jcol,jlev) =  total_cloud_cover *flux%sw_up(jcol,jlev) &
+                 &     + (1.0_jprb - total_cloud_cover)*flux%sw_up_clear(jcol,jlev)
+            flux%sw_dn(jcol,jlev) =  total_cloud_cover *flux%sw_dn(jcol,jlev) &
+                 &     + (1.0_jprb - total_cloud_cover)*flux%sw_dn_clear(jcol,jlev)
+            if (allocated(flux%sw_dn_direct)) then
+              flux%sw_dn_direct(jcol,jlev) = total_cloud_cover *flux%sw_dn_direct(jcol,jlev) &
+                   &  + (1.0_jprb - total_cloud_cover)*flux%sw_dn_direct_clear(jcol,jlev)
+            end if
+          end do
           ! Likewise for surface spectral fluxes
-          flux%sw_dn_diffuse_surf_g(:,jcol) = flux_dn_diffuse(:,nlev+1)
-          flux%sw_dn_direct_surf_g(:,jcol)  = flux_dn_direct(:,nlev+1)
-          flux%sw_dn_diffuse_surf_g(:,jcol) = total_cloud_cover *flux%sw_dn_diffuse_surf_g(:,jcol) &
-               &     + (1.0_jprb - total_cloud_cover)*flux%sw_dn_diffuse_surf_clear_g(:,jcol)
-          flux%sw_dn_direct_surf_g(:,jcol) = total_cloud_cover *flux%sw_dn_direct_surf_g(:,jcol) &
-               &     + (1.0_jprb - total_cloud_cover)*flux%sw_dn_direct_surf_clear_g(:,jcol)
-          
+          do jg = 1,ng
+            flux%sw_dn_diffuse_surf_g(jg,jcol) = flux_dn_diffuse(jg,nlev+1)
+            flux%sw_dn_direct_surf_g(jg,jcol)  = flux_dn_direct(jg,nlev+1)
+            flux%sw_dn_diffuse_surf_g(jg,jcol) = total_cloud_cover *flux%sw_dn_diffuse_surf_g(jg,jcol) &
+                 &                 + (1.0_jprb - total_cloud_cover)*flux%sw_dn_diffuse_surf_clear_g(jg,jcol)
+            flux%sw_dn_direct_surf_g(jg,jcol)  = total_cloud_cover *flux%sw_dn_direct_surf_g(jg,jcol) &
+                 &                 + (1.0_jprb - total_cloud_cover)*flux%sw_dn_direct_surf_clear_g(jg,jcol)
+          end do
+
         else
           ! No cloud in profile and clear-sky fluxes already
           ! calculated: copy them over
-          flux%sw_up(jcol,:) = flux%sw_up_clear(jcol,:)
-          flux%sw_dn(jcol,:) = flux%sw_dn_clear(jcol,:)
-          if (allocated(flux%sw_dn_direct)) then
-            flux%sw_dn_direct(jcol,:) = flux%sw_dn_direct_clear(jcol,:)
-          end if
-          flux%sw_dn_diffuse_surf_g(:,jcol) = flux%sw_dn_diffuse_surf_clear_g(:,jcol)
-          flux%sw_dn_direct_surf_g(:,jcol)  = flux%sw_dn_direct_surf_clear_g(:,jcol)
+          do jlev = 1, nlev+1
+            flux%sw_up(jcol,jlev) = flux%sw_up_clear(jcol,jlev)
+            flux%sw_dn(jcol,jlev) = flux%sw_dn_clear(jcol,jlev)
+            if (allocated(flux%sw_dn_direct)) then
+              flux%sw_dn_direct(jcol,jlev) = flux%sw_dn_direct_clear(jcol,jlev)
+            end if
+          end do
+          do jg = 1,ng
+            flux%sw_dn_diffuse_surf_g(jg,jcol) = flux%sw_dn_diffuse_surf_clear_g(jg,jcol)
+            flux%sw_dn_direct_surf_g(jg,jcol)  = flux%sw_dn_direct_surf_clear_g(jg,jcol)
+          end do
 
         end if ! Cloud is present in profile
@@ -307,18 +378,22 @@
       else
         ! Set fluxes to zero if sun is below the horizon
-        flux%sw_up(jcol,:) = 0.0_jprb
-        flux%sw_dn(jcol,:) = 0.0_jprb
-        if (allocated(flux%sw_dn_direct)) then
-          flux%sw_dn_direct(jcol,:) = 0.0_jprb
-        end if
-        flux%sw_up_clear(jcol,:) = 0.0_jprb
-        flux%sw_dn_clear(jcol,:) = 0.0_jprb
-        if (allocated(flux%sw_dn_direct_clear)) then
-          flux%sw_dn_direct_clear(jcol,:) = 0.0_jprb
-        end if
-        flux%sw_dn_diffuse_surf_g(:,jcol) = 0.0_jprb
-        flux%sw_dn_direct_surf_g(:,jcol)  = 0.0_jprb
-        flux%sw_dn_diffuse_surf_clear_g(:,jcol) = 0.0_jprb
-        flux%sw_dn_direct_surf_clear_g(:,jcol)  = 0.0_jprb
+        do jlev = 1, nlev+1
+          flux%sw_up(jcol,jlev) = 0.0_jprb
+          flux%sw_dn(jcol,jlev) = 0.0_jprb
+          if (allocated(flux%sw_dn_direct)) then
+            flux%sw_dn_direct(jcol,jlev) = 0.0_jprb
+          end if
+          flux%sw_up_clear(jcol,jlev) = 0.0_jprb
+          flux%sw_dn_clear(jcol,jlev) = 0.0_jprb
+          if (allocated(flux%sw_dn_direct_clear)) then
+            flux%sw_dn_direct_clear(jcol,jlev) = 0.0_jprb
+          end if
+        end do
+        do jg = 1,ng
+          flux%sw_dn_diffuse_surf_g(jg,jcol) = 0.0_jprb
+          flux%sw_dn_direct_surf_g(jg,jcol)  = 0.0_jprb
+          flux%sw_dn_diffuse_surf_clear_g(jg,jcol) = 0.0_jprb
+          flux%sw_dn_direct_surf_clear_g(jg,jcol)  = 0.0_jprb
+        end do
       end if ! Sun above horizon
 
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_save.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_save.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_save.F90	(revision 4853)
@@ -86,5 +86,5 @@
     end if
 
-    if (config%i_gas_model == IGasModelMonochromatic &
+    if (config%i_gas_model_lw == IGasModelMonochromatic &
          .and. config%mono_lw_wavelength > 0.0_jprb) then
       lw_units_str = 'W m-3'
@@ -515,5 +515,5 @@
     end if
 
-    if (config%i_gas_model == IGasModelMonochromatic &
+    if (config%i_gas_model_lw == IGasModelMonochromatic &
          .and. config%mono_lw_wavelength > 0.0_jprb) then
       lw_units_str = 'W m-3'
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_spartacus_sw.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_spartacus_sw.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_spartacus_sw.F90	(revision 4853)
@@ -87,5 +87,4 @@
     use radiation_constants, only      : Pi, GasConstantDryAir, &
          &                               AccelDueToGravity
-    USE mod_phys_lmdz_para
 
     implicit none
@@ -327,10 +326,4 @@
       write(nulout,'(a)',advance='no') '  Processing columns'
     end if
-
-      print*,'Dans radiation_spartacus, mpi_rank, omp_rank, &
-              size, chape inv_cloud = ',&
-              mpi_rank, omp_rank, &
-              shape(cloud%inv_cloud_effective_size), &
-              size(cloud%inv_cloud_effective_size)
 
     ! Main loop over columns
@@ -504,8 +497,4 @@
                &  .not. (nreg == 2 .and. cloud%fraction(jcol,jlev) &
                &  > 1.0-config%cloud_fraction_threshold)) then
-!           print*,' Dans radiation_spartacus mpi_rank, omp_rank, jcol, jlev, &
-!            &     cloud%inv_cloud_effective_size =', mpi_rank, &
-!            &     omp_rank, jcol, jlev, &
-!            &     cloud%inv_cloud_effective_size(jcol,jlev)
             if (cloud%inv_cloud_effective_size(jcol,jlev) > 0.0_jprb) then
               ! 3D effects are only simulated if
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_spectral_definition.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_spectral_definition.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_spectral_definition.F90	(revision 4853)
@@ -15,4 +15,6 @@
 !
 
+#include "ecrad_config.h"
+
 module radiation_spectral_definition
 
@@ -23,5 +25,5 @@
   public
 
-  real(jprb), parameter :: SolarReferenceTemperature = 5777.0_jprb ! K
+  real(jprb), parameter :: SolarReferenceTemperature       = 5777.0_jprb ! K
   real(jprb), parameter :: TerrestrialReferenceTemperature = 273.15_jprb ! K
 
@@ -85,5 +87,9 @@
   subroutine read_spectral_definition(this, file)
 
-    use easy_netcdf, only : netcdf_file
+#ifdef EASY_NETCDF_READ_MPI
+    use easy_netcdf_read_mpi, only : netcdf_file
+#else
+    use easy_netcdf,          only : netcdf_file
+#endif
     use yomhook,     only : lhook, dr_hook, jphook
 
@@ -132,12 +138,13 @@
 
   !---------------------------------------------------------------------
-  ! Store a simple band description by copying over the lower and
-  ! upper wavenumbers of each band
-  subroutine allocate_bands_only(this, wavenumber1, wavenumber2)
+  ! Store a simple band description by copying over the reference
+  ! temperature and the lower and upper wavenumbers of each band
+  subroutine allocate_bands_only(this, reference_temperature, wavenumber1, wavenumber2)
 
     use yomhook,     only : lhook, dr_hook, jphook
 
     class(spectral_definition_type), intent(inout) :: this
-    real(jprb),        dimension(:), intent(in)    :: wavenumber1, wavenumber2
+    real(jprb),                      intent(in)    :: reference_temperature    ! K
+    real(jprb),        dimension(:), intent(in)    :: wavenumber1, wavenumber2 ! cm-1
 
     real(jphook) :: hook_handle
@@ -152,5 +159,6 @@
     this%wavenumber1_band = wavenumber1
     this%wavenumber2_band = wavenumber2
-
+    this%reference_temperature = reference_temperature
+    
     if (lhook) call dr_hook('radiation_spectral_definition:allocate_bands_only',1,hook_handle)
 
@@ -167,4 +175,5 @@
     this%ng    = 0
     this%nband = 0
+    this%reference_temperature = -1.0_jprb
 
     if (allocated(this%wavenumber1))      deallocate(this%wavenumber1)
Index: /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_tripleclouds_lw.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_tripleclouds_lw.F90	(revision 4852)
+++ /LMDZ6/trunk/libf/phylmd/ecrad/radiation/radiation_tripleclouds_lw.F90	(revision 4853)
@@ -170,4 +170,7 @@
     logical :: is_clear_sky_layer(0:nlev+1)
 
+    ! Temporaries to speed up summations
+    real(jprb) :: sum_dn, sum_up
+    
     ! Index of the highest cloudy layer
     integer :: i_cloud_top
@@ -261,9 +264,21 @@
       if (config%do_clear) then
         ! Sum over g-points to compute broadband fluxes
-        flux%lw_up_clear(jcol,:) = sum(flux_up_clear,1)
-        flux%lw_dn_clear(jcol,:) = sum(flux_dn_clear,1)
+        do jlev = 1,nlev+1
+          sum_up = 0.0_jprb
+          sum_dn = 0.0_jprb
+          !$omp simd reduction(+:sum_up, sum_dn)
+          do jg = 1,ng
+            sum_up = sum_up + flux_up_clear(jg,jlev)
+            sum_dn = sum_dn + flux_dn_clear(jg,jlev)
+          end do
+          flux%lw_up_clear(jcol,jlev) = sum_up
+          flux%lw_dn_clear(jcol,jlev) = sum_dn
+        end do
+
         ! Store surface spectral downwelling fluxes / TOA upwelling
-        flux%lw_dn_surf_clear_g(:,jcol) = flux_dn_clear(:,nlev+1)
-        flux%lw_up_toa_clear_g (:,jcol) = flux_up_clear(:,1)
+        do jg = 1,ng
+          flux%lw_dn_surf_clear_g(jg,jcol) = flux_dn_clear(jg,nlev+1)
+          flux%lw_up_toa_clear_g (jg,jcol) = flux_up_clear(jg,1)
+        end do
         ! Save the spectral fluxes if required
         if (config%do_save_spectral_flux) then
@@ -453,5 +468,10 @@
           end if
         else
-          flux%lw_dn(jcol,:) = sum(flux_dn_clear(:,jlev))
+          sum_dn = 0.0_jprb
+          !$omp simd reduction(+:sum_dn)
+          do jg = 1,ng
+            sum_dn = sum_dn + flux_dn_clear(jg,jlev)
+          end do
+          flux%lw_dn(jcol,jlev) = sum_dn
           if (config%do_save_spectral_flux) then
             call indexed_sum(flux_dn_clear(:,jlev), &
@@ -470,5 +490,12 @@
            &  + total_albedo(:,1,i_cloud_top)*flux_dn_clear(:,i_cloud_top)
       flux_up(:,2:) = 0.0_jprb
-      flux%lw_up(jcol,i_cloud_top) = sum(flux_up(:,1))
+
+      sum_up = 0.0_jprb
+      !$omp simd reduction(+:sum_up)
+      do jg = 1,ng
+        sum_up = sum_up + flux_up(jg,1)
+      end do
+      flux%lw_up(jcol,i_cloud_top) = sum_up
+
       if (config%do_save_spectral_flux) then
         call indexed_sum(flux_up(:,1), &
@@ -478,5 +505,10 @@
       do jlev = i_cloud_top-1,1,-1
         flux_up(:,1) = trans_clear(:,jlev)*flux_up(:,1) + source_up_clear(:,jlev)
-        flux%lw_up(jcol,jlev) = sum(flux_up(:,1))
+        sum_up = 0.0_jprb
+        !$omp simd reduction(+:sum_up)
+        do jg = 1,ng
+          sum_up = sum_up + flux_up(jg,1)
+        end do
+        flux%lw_up(jcol,jlev) = sum_up
         if (config%do_save_spectral_flux) then
           call indexed_sum(flux_up(:,1), &
@@ -528,6 +560,15 @@
 
         ! Store the broadband fluxes
-        flux%lw_up(jcol,jlev+1) = sum(sum(flux_up,1))
-        flux%lw_dn(jcol,jlev+1) = sum(sum(flux_dn,1))
+        sum_up = 0.0_jprb
+        sum_dn = 0.0_jprb
+        do jreg = 1,nregions
+          !$omp simd reduction(+:sum_up, sum_dn)
+          do jg = 1,ng
+            sum_up = sum_up + flux_up(jg,jreg)
+            sum_dn = sum_dn + flux_dn(jg,jreg)
+          end do
+        end do
+        flux%lw_up(jcol,jlev+1) = sum_up
+        flux%lw_dn(jcol,jlev+1) = sum_dn
 
         ! Save the spectral fluxes if required
